package pmicrovenus;

import java.io.Serializable;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

@Entity
public abstract class Baraja implements Serializable {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;   	
    
    public static final int CARTA_SUERTE = 1;
    public static final int CARTA_COMUNIDAD = 2;    
    public abstract String getEtiqueta();    
    public abstract void aplicaAccion(Tablero t);    
    public abstract int getTipoCarta();
    public abstract boolean isLibre();
    
    
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Baraja)) {
            return false;
        }
        Baraja other = (Baraja)object;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) return false;
        return true;
    }

    @Override
    public String toString() {
        String res = "Baraja(" + id + ")";
        return res;
    }
    
}
